<?php
$apiKey     = 'AIzaSyCGLMyKebdLFBEgfzAkyRNhjjojQFxd7Io';
$channelId  = 'UCTD7UScwb7naKj4RqRKZ7aQ';
$delayTime  = 5000;

if(isset($_GET['delayBetweenVideos'])){
    $delayTime   = $_GET['delayBetweenVideos'];
}

if(isset($_GET['apiKey'])){
    $apiKey     = $_GET['apiKey'];
}
if(isset($_GET['channelid'])){
    $channelId  = $_GET['channelid'];
}

$apiBaseUrl = 'https://www.googleapis.com/youtube/v3';

function getYouTubeData($url) {
    $response = file_get_contents($url);
    return json_decode($response, true);
}

// Fetch all playlists
function getPlaylists($channelId, $apiKey, $apiBaseUrl) {
    $playlists = [];
    $url = "$apiBaseUrl/playlists?part=snippet&channelId=$channelId&maxResults=50&key=$apiKey";
    $data = getYouTubeData($url);

    if (!empty($data['items'])) {
        foreach ($data['items'] as $item) {
            $playlists[] = [
                'playlistId' => $item['id'],
                'title' => $item['snippet']['title'],
            ];
        }
    }

    return $playlists;
}

// Fetch videos from a playlist
function getPlaylistVideos($playlistId, $apiKey, $apiBaseUrl) {
    $videos = [];
    $url = "$apiBaseUrl/playlistItems?part=snippet&playlistId=$playlistId&maxResults=50&key=$apiKey";
    $data = getYouTubeData($url);

    if (!empty($data['items'])) {
        foreach ($data['items'] as $item) {
            $videos[] = [
                'videoId' => $item['snippet']['resourceId']['videoId'],
                'title' => $item['snippet']['title'],
                'thumbnail' => $item['snippet']['thumbnails']['default']['url'],
            ];
        }
    }

    return $videos;
}

// Get all playlists
$playlists = getPlaylists($channelId, $apiKey, $apiBaseUrl);

// Collect videos from both playlists
$allVideos = [];
if (!empty($playlists)) {
    $playlistCount = min(2, count($playlists)); // Limit to the first two playlists
    for ($i = 0; $i < $playlistCount; $i++) {
        $videos = getPlaylistVideos($playlists[$i]['playlistId'], $apiKey, $apiBaseUrl);
        $allVideos = array_merge($allVideos, $videos);
    }
}

?>

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>YouTube Video Player with Thumbnails</title>
    <style>
        body {
            font-family: Arial, sans-serif;
        }
        body iframe {  width: 100%;
            max-width: 767px;
            margin: 20px auto;
            display: block;
        }
        #playerdiv {
            width: 100%;
            max-width: 800px;
            margin: 20px auto;
        }
        .thumbnails {
            display: flex;
            flex-wrap: wrap;
            justify-content: center;
        }
        .thumbnail {
            margin: 10px;
            cursor: pointer;
        }
        .thumbnail img {
            width: 120px;
            height: auto;
            display: block;
        }
    </style>
</head>
<body>
<form action="" method="get">
    
  <label for="fname">Delay Time Between Videos:</label><br>
  <input type="text" id="" name="delayBetweenVideos" value="5000" style=" width: 500px;">
  <br>
  <br>
  <label for="fname">API Key:</label><br>
  <input type="text" id="" name="apiKey" value="AIzaSyCGLMyKebdLFBEgfzAkyRNhjjojQFxd7Io" style=" width: 500px;">
  <br>
  <br>
  <label for="lname">Channel Id:</label><br>
  <input type="text" id="" name="channelid" value="UCTD7UScwb7naKj4RqRKZ7aQ" style=" width: 500px;"><br><br>
  <input type="submit" value="Submit">
</form> 

<div id="player">
    <iframe id="videoPlayer" width="700" height="450" src="https://www.youtube.com/embed/<?php echo $allVideos[0]['videoId']; ?>?autoplay=1&mute=1" frameborder="0" allowfullscreen></iframe>
</div>

<div class="thumbnails">
    <?php foreach ($allVideos as $video): ?>
        <div class="thumbnail" onclick="playVideo('<?php echo $video['videoId']; ?>')">
            <img src="<?php echo $video['thumbnail']; ?>" alt="<?php echo $video['title']; ?>">
            <p><?php echo $video['title']; ?></p>
        </div>
    <?php endforeach; ?>
</div>

<script>
    const allVideos  = <?php echo json_encode($allVideos); ?>;
    let currentIndex = 0;
    const delayBetweenVideos  = <?php echo $delayTime; ?>; // 5 seconds delay
    //let delayBetweenVideos = delayTime.trim();

    let player;
    console.log(delayBetweenVideos);
    function playVideo(videoId) {
        console.log('Playing video:', videoId);
        if (player) {
            player.loadVideoById(videoId);
        } else {
            console.error('Player is not initialized');
        }
    }

    function playNextVideo() {
        currentIndex++;
        if (currentIndex < allVideos.length) {
            setTimeout(() => {
                console.log('Playing next video:', allVideos[currentIndex].videoId);
                playVideo(allVideos[currentIndex].videoId);
            }, delayBetweenVideos);
        } else {
            console.log('No more videos to play');
        }
    }

    function onYouTubeIframeAPIReady() {
        console.log('YouTube IFrame API is ready');
        player = new YT.Player('player', {
          playerVars: {
                    autoplay: 1,
                    controls: 1,
                    showinfo: 1,
                    autohide: 0,
                    mute:1
                    },
          videoId: allVideos[0].videoId,
          events: {
            'onStateChange': onPlayerStateChange
          }
        });
      }

    function onPlayerStateChange(event) {
        console.log("Player state changed:", event.data);
        if (event.data === YT.PlayerState.ENDED) {
            console.log('Video ended');
            playNextVideo();
        }
    }

    // Load the IFrame API script
    const tag = document.createElement('script');
    tag.src = "https://www.youtube.com/iframe_api";
    tag.onload = function() {
        console.log('YouTube IFrame API script loaded');
    };
    document.body.appendChild(tag);
</script>

</body>
</html>
