<?php

$apiKey = 'AIzaSyCGLMyKebdLFBEgfzAkyRNhjjojQFxd7Io';
$channelId = 'UCTD7UScwb7naKj4RqRKZ7aQ';
$apiBaseUrl = 'https://www.googleapis.com/youtube/v3';

function getYouTubeData($url) {
    $response = file_get_contents($url);
    return json_decode($response, true);
}

// Fetch all playlists
function getPlaylists($channelId, $apiKey, $apiBaseUrl) {
    $playlists = [];
    $url = "$apiBaseUrl/playlists?part=snippet&channelId=$channelId&maxResults=50&key=$apiKey";
    $data = getYouTubeData($url);

    if (!empty($data['items'])) {
        foreach ($data['items'] as $item) {
            $playlists[] = [
                'playlistId' => $item['id'],
                'title' => $item['snippet']['title'],
            ];
        }
    }

    return $playlists;
}

// Fetch videos from a playlist
function getPlaylistVideos($playlistId, $apiKey, $apiBaseUrl) {
    $videos = [];
    $url = "$apiBaseUrl/playlistItems?part=snippet&playlistId=$playlistId&maxResults=50&key=$apiKey";
    $data = getYouTubeData($url);

    if (!empty($data['items'])) {
        foreach ($data['items'] as $item) {
            $videos[] = [
                'videoId' => $item['snippet']['resourceId']['videoId'],
                'title' => $item['snippet']['title'],
                'thumbnail' => $item['snippet']['thumbnails']['default']['url'],
            ];
        }
    }

    return $videos;
}

// Get all playlists
$playlists = getPlaylists($channelId, $apiKey, $apiBaseUrl);

// Collect videos from both playlists
$allVideos = [];
if (!empty($playlists)) {
    $playlistCount = min(2, count($playlists)); // Limit to the first two playlists
    for ($i = 0; $i < $playlistCount; $i++) {
        $videos = getPlaylistVideos($playlists[$i]['playlistId'], $apiKey, $apiBaseUrl);
        $allVideos = array_merge($allVideos, $videos);
    }
}

?>

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>YouTube Video Player with Thumbnails</title>
    <style>
        body {
            font-family: Arial, sans-serif;
        }
        #player {
            width: 100%;
            max-width: 800px;
            margin: 20px auto;
        }
        .thumbnails {
            display: flex;
            flex-wrap: wrap;
            justify-content: center;
        }
        .thumbnail {
            margin: 10px;
            cursor: pointer;
        }
        .thumbnail img {
            width: 120px;
            height: auto;
            display: block;
        }
    </style>
</head>
<body>
https://www.youtube.com/embed/<?php echo $allVideos[0]['videoId']; ?>?playlist=<?php echo implode(',', array_column($allVideos, 'videoId')); ?>
<div id="player">
    <iframe id="videoPlayer" width="800" height="450" src="https://www.youtube.com/embed/<?php echo $allVideos[0]['videoId']; ?>?playlist=<?php echo implode(',', array_column($allVideos, 'videoId')); ?>&autoplay=1&mute=1" frameborder="0" allowfullscreen></iframe>
</div>

<div class="thumbnails">
    <?php foreach ($allVideos as $video): ?>
        <div class="thumbnail" onclick="playVideo('<?php echo $video['videoId']; ?>')">
            <img src="<?php echo $video['thumbnail']; ?>" alt="<?php echo $video['title']; ?>">
            <p><?php echo $video['title']; ?></p>
        </div>
    <?php endforeach; ?>
</div>

<script>
    function playVideo(videoId) {
        document.getElementById('videoPlayer').src = 'https://www.youtube.com/embed/' + videoId + '?playlist=<?php echo implode(',', array_column($allVideos, 'videoId')); ?>';
    }
</script>

</body>
</html>
